package com.trust.ywx.customer.common.enu;

/**
 * <pre></pre>
 *
 * @文件名称： Firm.java
 * @包 路  径： com.trust.ywx.customer.common.enums
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 通用枚举值 0-false；1-true
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 13:31
 * @Modify：
 */
public enum CommonStatusEnum {
    YES(1, "true"), // 是
    NO(0, "false"), // 否
    ;

    private int code;
    private String name;

    private CommonStatusEnum(int code, String name) {
        this.code = code;
        this.name = name;
    }

    public static String getNameOfCode(int code) {
        switch (code) {
            case 1:
                return YES.getName();
            case 0:
                return NO.getName();
            default:
                return "unknow";
        }
    }
    public static int getCodeOfName(String name) {
        switch (name) {
            case "true":
                return YES.getCode();
            case "false":
                return NO.getCode();
            default:
                return 0;
        }
    }
    public String getName() {
        return name;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public void setName(String name) {
        this.name = name;
    }
}
