package com.trust.ywx.customer.common.enu;

/**
 * ************************************************************************
 * <pre></pre>
 *
 * @文件名称: FirmErrEum.java
 * @包 路   径：  cn.org.bjca.ywq.admin.exception
 * @版权所有：北京数字认证股份有限公司 (C) 2016
 * @类描述:
 * @版本: V1.5
 * @创建人： liuchongzhi
 * @创建时间：2016/11/14 9:45
 * <p/>
 * <p/>
 * *************************************************************************
 */

public enum FirmErrEum {
	// 004x000 ~ 004x010
	FIRM_CLIENT_ID_NULL("004x000","厂商id不能为空"),
	FIRM_APP_SECRET_NULL("004x001","APP_SECRET不能为空"),
	FIRM_NAME_NULL("004x002","厂商名称不能为空"),
	FIRM_PERSON("004x003","厂商联系人不能为空"),
	FIRM_PHONE("004x004","厂商联系方式不能为空"),
	FIRM_UNIQUEID("004x005","厂商唯一标识不能为空"),
	FIRM_CERTAGENCY("004x006","凭证类型不能为空"),
	FIRM_SMS_CUSTOMIZECONTENT_TOOLONG("004x007","自定义模板短信内容不能超过100个字符"),
	FIRM_NAME_CHECK_ERR("004x008","厂商名称已存在")	,
	CLIENTID_CHECK_ERR("004x009","厂商id已存在"),
	OP_FIRM_CKECK_ERROR("004x010","开放平台无此厂商账号"),
	// 004x011 ~ 004x020
	FIRM_NOT_EXIST("004x011","应用厂商不存在"),
	FIRM_STATUS_ERR("004x012","应用厂商状态不正确"),
	FIRM_DELETE_SUBSCRIBE_ERR("004x013","订阅服务正在使用，不能删除"),
	FIRM_MODIFY_SUBSCRIBE_ERR("004x014","当前服务包中有正在使用项，不能修改或者删除"),

	FIRM_UPDATE_ERR("004x015","厂商更新数据失败"),
	FIRM_NOTIFY_SERVER_ERR("004x016","厂商服务包更新数据失败"),
	NOTIFY_SYN_DOCTOR_URL_MISS("004x017", "缺失医师同步通知URL地址"),
	NOTIFY_SYN_PATIENT_URL_MISS("004x018", "缺失患者同步通知URL地址"),
	NOTIFY_RECIPE_SIGN_URL_MISS("005x004", "缺失处方签名通知URL地址"),
	FIRM_STAMP_ERR("004x019", "厂商制章失败"),
	FIRM_XBY_ENTERPRISE_ERR("004x020", "信步云添加企业失败"),
	FIRM_CERT_REQUEST_ERR("004x021", "厂商证书申请失败"),
	NOTIFY_FIRM_PDF_SIGN_URL_MISS("004x022", "缺失厂商PDF签名通知URL地址"),
	FIRM_NAME_TOO_LONG("004x023","厂商名称超过30位"),
	FIRM_SUB_DEPART_EXIST_ERR("004x024","厂商下面包含子厂商，不能进行删除"),
	FIRM_EXIST_ERR("004x025", "同一个openID厂商存在多个"),
	FIRM_EXIST_TRUST_ERR("004x026", "该厂商已注册过"),
	FIRM_SYN_ERR("004x027", "修改厂商数据库失败"),
	FIRM_OPENID_NULL_ERR("004x028", "openId不能为空"),
	FIRM_REALNAME_ERR("004x029", "没有进行实名认证"),
	INDENTITY_SUCCESS_STATUS("004x030","调用认证接口成功"),
	INDENTITY_FAIL_STATUS("004x031","调用认证接口失败"),
	IDENTITY_NOPASS("004x032","认证未通过"),
	IDENTITY_FAIL("004x033","认证失败"),
	REALNAME_SYS_ERR("004x034","实名认证暂未开通"),
	FIRM_NSID_NULL_ERR("004x035","服务类型不可为空"),
	FIRM_THRESHOULD_WARN_NULL_ERR("004x036","需要阀值，请填写"),
	FIRM_SMS_CUSTOMIZE_CONTENT_NULL_ERR("004x037","需要短信定制的内容，请填写"),
	FIRM_FEE_MODEL_NULL_ERR("004x038","已选择服务包，收费模式不能为空"),
	NOTIFY_SYN_DOCTOR_ORDER_MISS("004x039", "未获取到医师用户审核异步通知的服务订单"),
	NOTIFY_SERVER_URL_NULL_ERR("004x041", "服务通知地址不能为空"),
	NOTIFY_URL_CONN_TIMEOUT_ERR("004x042","回调通知地址连接超时"),
	FIRM_CHANNEL_TYPE_NULL_ERR("004x043","渠道类型不能为空"),
	FIRM_STAMP_TYPE_NULL_ERR("004x044","请确定厂商签章类型（圆章 or 方章）"),
	FIRM_CA_CHANNEL_ERR("004x045","厂商ca渠道错误"),
	FIRM_CA_CHANNEL_CHANGE_ERR("004x046","厂商ca渠道不允许更换"),
	FIRM_USERCERT_APP_CHANNEL_ERR("005x001","厂商用户证书app渠道添加失败"),
	FIRM_USERCERT_SDK_CHANNEL_ERR("005x002","厂商用户证书sdk渠道添加失败"),

	FIRM_CHANNEL_ERR("005x003","厂商渠道表数据有误"),
	FIRM_DOCTOR_PUBLIC_TYPE_ERR("005x004","医师产品形态参数错误"),
	NOTIFY_SERVICE_SUBSCRIBE_TYPE_ERR("005x022", "回调通知地址类型有误"),
	
	FIRM_SER_ORDER_ERR("006x001","分页查询厂商服务包订单记录数据时出错"),
	FIRM_OP_PW_UPDATE_ERR("006x002","开放平台厂商密码重置失败"),

	FIRM_GROUP_FRIM_CHECK_ERR("007x001","厂商组关联关系异常"),
	FIRM_GROUP_ADD_ERR("007x002","厂商组添加失败"),
	FIRM_GROUP_LEADER_MEMBER_ERR("007x003","厂商组添加失败,组员中不能含有组长"),
	FIRM_GROUP_ADD_MEMBER_ERR("007x004","厂商组添加组员失败"),

	AGENT_SALE_AND_OR_UPDATE_ERR("008x001","代理商销售添加或更新失败"),
	AGENT_SALE_DELETE_ERR("008x002","代理商删除失败"),
	FIRM_ICON_TOOBIG("008x003","厂商icon不能超过64K"),
	REJECT_REASON_TOO_LONG("008x004","拒绝原因过长"),
	DEPART_NAME_EMPTY("008x005","客户名称为空"),

	CLIENT_ORG_CODE_NULL("008x006","客户的统一信用代码为空"),
	SUPPORT_INFO_TOOLONG("008x007","实施支持内容及验收标准超长，仅支持最多300字符"),
	CLIENT_ORG_CODE_CHECK_ERR("008x008","客户的统一信用代码已存在"),
	;

	/**
	 * 状态码
	 */
	private String status;

	/**
	 * 消息
	 */
	private String message;

	FirmErrEum(String status, String message) {
		this.status = status;
		this.message = message;
	}

	public String getStatus() {
		return status;
	}

	public String getMessage() {
		return message;
	}
}
