package com.trust.ywx.customer.common.enu;

import java.util.Objects;

/***************************************************************************
 * <pre></pre>
 * @文件名称: FirmProperEnum.java
 * @包 路   径：  cn.org.bjca.ywq.firm.cons
 * @版权所有：北京数字认证股份有限公司 (C) 2018
 *
 * @类描述:
 * @版本: V1.5
 * @创建人： hudan
 * @创建时间：2018年2月27日 下午7:36:58
 *
 * @修改记录：
 **/
public enum FirmProperEnum {

    //---------------------------基础配置-------------------------------------
    CHARGING_MODE("charging_model", "计费模式"),//0-规则计费 1-异常计费

    TECHPERSON_SUPPORT("techperson.support", "是否需要实施支持"),//0-否 1-是
    TECHPERSON_SUPPORT_INFO("techperson.support.info", "实施支持内容及验收标准"),

    PUBLIC_PRODUCT_TYPE("public_product_type", "公众端产品形态"),//单选 ！空-未选择；SDK-SDK； H5-H5
    // fixme 目前放在firm_usercert_channel的channel_type 0-APP；1-SDK ；一个客户可以有多条记录
	DOCTOR_PRODUCT_APP("doctor_product_APP", "医师端产品形态-APP"),//空-未选择；0-未勾选 1-勾选
	DOCTOR_PRODUCT_SDK("doctor_product_SDK", "医师端产品形态-SDK"),//空-未选择；0-未勾选 1-勾选

    NETWORK_TYPE("network_type", "客户类型"),//gateway-网关版，it-互联网)
    //通讯平台专属配置
    GATEWAY_VERSION("gateway_version", "通讯平台版本"),//网络环境，若网关或网闸版本需注明版本 目前已自动上报了。前端不需要设置
    HISCA_NAME("hisca_name", "内控平台名称"),
    HISCA_LOGO("hisca_logo", "内控平台logo"),
    HISCA_PUBLICITY("hisca_publicity", "内控平台宣传图片"),
    HISCA_MONITOR_URL("hisca_monitor_url", "内控平台监控地址"),
    GATEWAY_MONITOR_URL("gateway_monitor_url", "通信平台监控地址"),
    HISCA_CALL_URL("hisca_call_url", "内控平台回调地址"),
    // 通讯平台专属配置 end


    FIRM_MODE("firm_mode", "客户"),//0-普通客户 1-冠新客户 2-微医 3-阿里客户
    //fixme 证书算法 目前存在firm_info表的cert_alg，以后需要迁移到firm_info_extends表
    CERT_ALG("cert_alg", "证书算法"),//RSA/SM2

    CA_CHANNEL("ca_type", "CA渠道"),//CA渠道 0-北京ca 1-深圳ca 2-广西ca 3-新疆ca see com.trust.ywx.customer.common.enums.CaChannelEnum

    FIRM_ALLOW_USER_BIND("allowUserBind", "用户挂靠"),//是否允许医生挂靠 0-否 1-是
    FIRM_SHOW_INBINDLIST("showFirmInBindList", "挂靠列表里是否显示"),//挂靠医院是否展示  0-否 1-是


    //---------------------------可选配置及服务-------------------------------------
    // 审核短信
    //fixme 审核完成发送短信 目前存在firm_info表的send_sms，以后需要迁移到firm_info_extends表
    SMS_SEND("sms_send", "是否短信定制"), //N-否 Y-是
    SMS_CUSTOMIZE("sms_customize", "是否短信定制"), //N或者空-否 Y-是
    SMS_CUSTOMIZE_CONTENT("sms_customize_content", "短信定制内容"),

    // 医生签名增强功能 拒签、作废、人脸识别
    REJECT_SIGN("reject_sign", "是否拒签"),// false或者空-否 true-是
    INVALID_SIGN("invalid_sign", "是否作废"),//false或者空-否 true-是
    FACE_DETECT("face_detect", "人脸识别"),// 0-否 1-是

    //公众签名增强功能
    PUBLIC_SIGN_PHOTO("wx_is_photo", "人像采集"),//微信公众H5采集签名是否开启照片 N-否 Y-是

    //个人图章样式
    USER_STAMP_TYPE("user_stamp_type", "个人图章样式"), //stamp-默认；stamp1-签章样式1
    //个人图章模式 自动设置图章、图章审核、app设置图章、图章压缩
    STAMP_IS_CHECK("stamp_is_check", "图章审核"),// 签章是否需要审核 N或者空-否; Y-是
    STAMP_IS_APPCLOSE("stamp_is_appclose", "app设置图章"),// N或者空-否; Y-是
    USER_STAMP_COMPRESS("user_stamp_compress", "图章压缩"),//用户签名图章是否压缩 0-压缩(默认) ；1-不压缩
    //fixme 目前存放与firm_info表的stamp_type。以后需要迁移到firm_info_extends表
    STAMP_AUTO_SET("stamp_type", "自动设置图章"),//是否自动设置图章 0-否 ；1-是
    //个人图章模式 end

    //企业图章模式 方章、圆章、客户图章日期、子客户图章日期
    FIRM_STAMP_TYPE("firm_stamp_type", "厂商签名图章类型"),// 0-圆章 1-方章
    FIRM_STAMP_TS("firm_stamp_ts", "客户图章日期"), //0或者空-未勾选 1-勾选
    DEPART_STAMP_TS("depart_stamp_ts", "子客户图章日期"), //0或者空-未勾选 1-勾选

    //PDF水印功能
    FIRM_PERSONPDF_WATER("personPdfWater", "个人PDF"),//个人PDF增加水印 0-未勾选 1-增加水印
    FIRM_APPENDPDF_WATER("appendPdfWater", "附件PDF"),//附件PDF增加水印 0-未勾选 1-增加水印

    //自动签增强功能
    SELF_SIGN_BY_FIRM("self_sign_by_firm", "用户无感知"),//0-默认关闭; 1-开启
    ;


    /**
     * 判断是否为合法属性
     * @param properName
     * @return
     */
    public static boolean isLegalProp(String properName) {
        for (FirmProperEnum t : FirmProperEnum.values()) {
            if (Objects.equals(t.getProperName(),properName)) {
                return true;
            }
        }
        return false;
    }

    private FirmProperEnum(String properName, String properDesc) {
        this.properName = properName;
        this.properDesc = properDesc;

    }

    private String properName;

    private String properDesc;

    public String getProperName() {
        return properName;
    }

    public String getProperDesc() {
        return properDesc;
    }

    }
