package com.trust.ywx.customer.common.enu;

import java.util.Objects;

/**
 * <pre></pre>
 *
 * @文件名称： Firm.java
 * @包 路  径： com.trust.ywx.customer.common.enums
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: fixme 目前数据库中存的是name，以后希望改成code（int）
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 13:31
 * @Modify：
 */
public enum NetworkTypeEnum {
    GATEWAY(1, "gateway"),
    IT(2, "it"),
    ;

    private int code;
    private String name;

    private NetworkTypeEnum(int code, String name) {
        this.code = code;
        this.name = name;
    }

    // 普通方法
    public static String getNameOfCode(int code) {
        for (NetworkTypeEnum t : NetworkTypeEnum.values()) {
            if (t.getCode() == code) {
                return t.getName();
            }
        }
        return null;
    }
    // 普通方法
    public static int getCodeOfName(String name) {
        for (NetworkTypeEnum t : NetworkTypeEnum.values()) {
            if (Objects.equals(t.getName(),name)) {
                return t.getCode();
            }
        }
        return -1;
    }

    public String getName() {
        return name;
    }

    public int getCode() {
        return code;
    }

}
