package com.trust.ywx.customer.common.enu;

/**
 * <pre></pre>
 *
 * @文件名称： Firm.java
 * @包 路  径： com.trust.ywx.customer.common.enums
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 项目状态
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 13:31
 * @Modify：
 */
public enum ProjectStatusEnum {
    NORMAL(1, "正常"),
    TRYING(2, "试用"),
    EXTINCT(3, "消亡"),
    DEL(4, "删除"),
    ;

    private int code;
    private String name;

    private ProjectStatusEnum(int code, String name) {
        this.code = code;
        this.name = name;
    }

    public static String getNameOfCode(int code) {
        switch (code) {
            case 1:
                return NORMAL.getName();
            case 2:
                return TRYING.getName();
            case 3:
                return EXTINCT.getName();
            case 4:
                return DEL.getName();
            default:
                return "unknow";
        }
    }

    public String getName() {
        return name;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public void setName(String name) {
        this.name = name;
    }
}
