package com.trust.ywx.customer.common.enu;

import java.util.Objects;

/**
 * <pre></pre>
 *
 * @文件名称： Firm.java
 * @包 路  径： com.trust.ywx.customer.common.enums
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 13:31
 * @Modify：
 */
public enum PublicProductTypeEnum {
    SDK(0,"SDK"),
    H5(1,"H5"),;

    private int code;
    private String name;

    private PublicProductTypeEnum(int code, String name){
        this.code= code;
        this.name = name;
    }


    // 普通方法
    public static int getCode(String name) {
        for (PublicProductTypeEnum t : PublicProductTypeEnum.values()) {
            if (Objects.equals(t.getName(),name)) {
                return t.getCode();
            }
        }
        return -1;
    }

    public static String getName(int code) {
        for (PublicProductTypeEnum t : PublicProductTypeEnum.values()) {
            if (t.getCode() == code) {
                return t.getName();
            }
        }
        return "unknow";
    }


    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
