package com.trust.ywx.customer.common.model.manager.request;

import com.trust.ywx.customer.common.model.manager.request.FirmPropParam;
import lombok.Data;

import java.util.Date;

/**
 * <pre></pre>
 *
 * @文件名称： TrustFirmParam.java
 * @包 路  径： com.trust.ywx.customer.common.model.manager.request
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/17 10:45
 * @Modify：
 */
@Data
public class TrustFirmParam extends FirmPropParam {

    private static final long serialVersionUID = 8183777452023821497L;
    /**
     * 客户id
     */
    private String clientId;
    /**
     * 客户名称
     */
    private String firmName;

    /**
     * 第三方应用APP_SECRET
     *
     */
    private String appSecret;

    /**
     * 客户联系电话
     */
    private String firmPhone;
    /**
     * 客户地址
     */
    private String firmAddress;

    /**
     * 客户联系人
     *
     */
    private String firmPerson;

    /**
     * 证书算法 RSA/SM2
     */
    private String certAlg;

    /**
     * 客户邮箱
     */
    private String firmEmail;

    /**
     * 客户描述
     *
     * fixme 前端没看到有这个字段
     */
    @Deprecated
    private String note;


    /**
     * 统一信用代码
     */
    private String clientOrgCode;

    /**
     * 项目状态
     * see com.trust.ywx.customer.common.enu.ProjectStatusEnum
     */

    private Integer projectStatus;
    /**
     * 审核状态
     * see com.trust.ywx.customer.common.enu.FirmStatusEnum
     */
    private Integer FirmStatus;

    /**
     * 信步云appid
     *
     */
    private String msspAppid;

    /**
     * 证书发放厂家
     *
     */
    private String certAgency;

    /**
     * 0 手动制章 1 自动制章
     * 改参数迁移至FirmPropParam.stampType
     */
//    private String stampType;

    /**
     * 外键id
     *
     */
    private String openId;

    /**
     * 审核(医生审核、等)完成之后是否发送短信提示
     * Y-是 N-否
     * 改参数迁移至FirmPropParam.sendSms
     */
//    private String sendSms;

    /**
     * 销售人员id
     *
     */
    private String salePersonId;

    /**
     * 实施人员
     *
     */
    private String techPersonId;

    /**
     * 创建
     *
     */
    private Date createTime;

    /**
     * 修改时间
     */
    private Date updateTime;

    /**
     * 代理厂商id
     */
    private String agentClientId;

    /**
     * 代理商销售
     *
     */
    private String agentSaleId;

    /**
     * CA 渠道
     */
    private Integer caChannel;

    /**
     * 应用app图标
     */
    private String appIcon;


    /**
     * 数字认证运营平台app_id
     */
    private Integer platAppId;

}
