package com.trust.ywx.customer.common.model.query.request;

import com.fiftyonetrust.common.model.param.PageParam;
import lombok.Data;

/***************************************************************************
 * <pre></pre>
 * @文件名称:  Search1FirmParam.java
 * @包   路   径：  cn.org.bjca.ywq.api.param.req
 * @版权所有：北京数字认证股份有限公司 (C) 2017
 *
 * @类描述: 查询可信客户参数
 * @版本: V1.5
 * @创建人： hbx
 * @创建时间：2017年3月13日 下午1:54:17
 */
@Data
public class SearchTrustFirmParam extends PageParam{
	/**
	 * 客户id
	 */
	private String clientId;
	/**
	 * 客户名称
	 */
	private String firmName;
	/**
	 * 代理商id
	 */
	private String agentClientId;
	/**
	 * 审核状态
	 */
	private Integer status;

	/**
	 * 销售人员id
	 */
	private String saleId;

	/**
	 * 实施人员id
	 */
	private String techId;

	// fixme 要不要支持客户配置属性查询？
	/**
     * 客户类型：互联网医院、实体医院等
	 * see com.trust.ywx.customer.common.enums.NetworkTypeEnum
	 */
	private Integer networkType;
	/**
     * 医师产品形态
	 * see com.trust.ywx.customer.common.enums.DoctorProductTypeEnum
	 */
	private Integer doctorProductType;
	/**
     * 公众产品形态 SDK\H5
	 * see com.trust.ywx.customer.common.enums.PublicProductTypeEnum
	 */
	private Integer publicProductType;

	/**
	 * 计费模式 0正常 1异常
	 * see com.trust.ywx.customer.common.enums.ChargingModelEnum
	 */
	private Integer chargingMode;

	/**
	 * 厂商组id
	 */
	private String groupId;

	/**
	 * 项目状态 1、正常/2、试用/3、消亡/4、删除
	 * see com.trust.ywx.customer.common.enums.ChargingModelEnum
	 */
	private Integer projectStatus;

}
