package com.trust.ywx.customer;

import lombok.extern.slf4j.Slf4j;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.autoconfigure.jdbc.DataSourceTransactionManagerAutoConfiguration;
import org.springframework.boot.autoconfigure.mongo.MongoAutoConfiguration;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.ComponentScans;
import org.springframework.context.annotation.ImportResource;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 * <pre></pre>
 *
 * @文件名称： TrustCustomerService.java
 * @包 路  径： com.trust.ywx.customer.service.exceptions
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 客户中心服务启动类
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/11 21:15
 * @Modify：
 */
@Slf4j
@ImportResource(locations = {"classpath:spring/spring-applicationContext.xml",})
//@ComponentScan(basePackages = {"com.trust.ywx.customer",})
@SpringBootApplication(scanBasePackages = {"com.trust.ywx.customer"})
public class Application {

    public static void main(String[] args) {
        SpringApplication.run(Application.class, args);
    }

}
