package com.trust.ywx.customer.dao;

import com.trust.ywx.customer.dao.mapper.FirmUsercertChannelMapper;
import com.trust.ywx.customer.dao.po.FirmUsercertChannel;
import com.trust.ywx.customer.dao.po.FirmUsercertChannelExample;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <pre></pre>
 *
 * @文件名称： FirmDao.java
 * @包 路  径： com.trust.ywx.customer.dao
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 医师产品形态dao fixme 以后要合并到firm_info_extends
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 10:31
 * @Modify：
 */
@Repository
public class DoctorProductTypeDao {

    @Resource
    private FirmUsercertChannelMapper usercertChannelMapper;

    public List<String> getClientIdByProp(List<String> clientIdList,Integer doctorProductType){
        FirmUsercertChannelExample example = new FirmUsercertChannelExample();
        example.createCriteria().andChannelTypeEqualTo(doctorProductType).andClientidIn(clientIdList);
        List<FirmUsercertChannel> list = usercertChannelMapper.selectByExample(example);
        if(CollectionUtils.isEmpty(list)) {
            return Arrays.asList();
        }
        return  list.stream().map(group-> group.getFirmId()).collect(Collectors.toList());
    }

    public List<FirmUsercertChannel> getByClientId(String clientId){
        FirmUsercertChannelExample example = new FirmUsercertChannelExample();
        example.createCriteria().andClientidEqualTo(clientId);
        List<FirmUsercertChannel> list = usercertChannelMapper.selectByExample(example);
        if(CollectionUtils.isEmpty(list)) {
            return Arrays.asList();
        }
        return list;
    }


}
