package com.trust.ywx.customer.dao;

import com.trust.ywx.customer.dao.mapper.FirmGroupMapper;
import com.trust.ywx.customer.dao.po.FirmGroup;
import com.trust.ywx.customer.dao.po.FirmGroupExample;
import org.springframework.stereotype.Repository;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <pre></pre>
 *
 * @文件名称： FirmDao.java
 * @包 路  径： com.trust.ywx.customer.dao
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 客户组查询DAO
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 10:31
 * @Modify：
 */
@Repository
public class FirmGroupDao {

    @Resource
    private FirmGroupMapper firmGroupMapper;

    public List<String> getClientIdByGroupId(String groupId){
        List<FirmGroup> groupsList = getListByGroupId(groupId);
        List<String > clientIdList = groupsList.stream().map(group->{return group.getFirmId();}).collect(Collectors.toList());
        return clientIdList;
    }


    public List<FirmGroup> getListByGroupId(String groupId){
        FirmGroupExample example = new FirmGroupExample();
        example.createCriteria().andGroupIdEqualTo(groupId).andIsDelEqualTo(0);

        return firmGroupMapper.selectByExample(example);
    }

}
