//package com.trust.ywx.customer.dao;
//
//import com.alibaba.druid.pool.DruidDataSource;
//import org.apache.ibatis.session.SqlSessionFactory;
//import org.mybatis.spring.SqlSessionFactoryBean;
//import org.mybatis.spring.annotation.MapperScan;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.context.annotation.Bean;
//import org.springframework.context.annotation.Configuration;
//import org.springframework.context.annotation.Primary;
//import org.springframework.core.env.Environment;
//import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
//import org.springframework.jdbc.datasource.DataSourceTransactionManager;
//import org.springframework.transaction.annotation.EnableTransactionManagement;
//
//import javax.annotation.Resource;
//import javax.sql.DataSource;
//import java.sql.SQLException;
//
///**
// * *************************************************************************
// * <pre></pre>
// *
// * @文件名称: MyBatisConfiguration
// * @包 路 径： bjca.yiwangqian.wjw.boot.config
// * @版权所有：北京数字认证股份有限公司 (C) 2019
// * @类描述:
// * @版本: V1.5 @创建人： hudan
// * @创建时间：2019年2月27日
// */
//@Configuration
//@MapperScan(value = {"com.trust.ywx.customer.dao.mapper"})
//@EnableTransactionManagement
//public class MyBatisConfiguration {
//
//    @Resource
//    private Environment env;
//
//    @Value("${jdbc.url}")
//    private String dbUrl;
//    @Value("${jdbc.username}")
//    private String username;
//    @Value("${jdbc.password}")
//    private String password;
//    @Value("${spring.datasource.driver-class-name}")
//    private String driverClassName;
//    @Value("${spring.datasource.initialSize}")
//    private int initialSize;
//    @Value("${spring.datasource.minIdle}")
//    private int minIdle;
//    @Value("${spring.datasource.maxActive}")
//    private int maxActive;
//    @Value("${spring.datasource.maxWait}")
//    private int maxWait;
//    @Value("${spring.datasource.timeBetweenEvictionRunsMillis}")
//    private int timeBetweenEvictionRunsMillis;
//    @Value("${spring.datasource.minEvictableIdleTimeMillis}")
//    private int minEvictableIdleTimeMillis;
//    @Value("${spring.datasource.validationQuery}")
//    private String validationQuery;
//    @Value("${spring.datasource.testWhileIdle}")
//    private boolean testWhileIdle;
//    @Value("${spring.datasource.testOnBorrow}")
//    private boolean testOnBorrow;
//    @Value("${spring.datasource.testOnReturn}")
//    private boolean testOnReturn;
//    @Value("${spring.datasource.poolPreparedStatements}")
//    private boolean poolPreparedStatements;
//    @Value("${spring.datasource.maxPoolPreparedStatementPerConnectionSize}")
//    private int maxPoolPreparedStatementPerConnectionSize;
//    @Value("${spring.datasource.filters}")
//    private String filters;
//    @Value("${spring.datasource.connectionProperties}")
//    private String connectionProperties;
//    @Value("${spring.datasource.useGlobalDataSourceStat}")
//    private boolean useGlobalDataSourceStat;
//
//    @Bean(name = "dataSource")     //声明其为Bean实例
//    @Primary  //在同样的DataSource中，首先使用被标注的DataSource
//    public DataSource dataSource() {
//        DruidDataSource datasource = new DruidDataSource();
//        datasource.setUrl(this.dbUrl);
//        datasource.setUsername(username);
//        datasource.setPassword(password);
//        datasource.setDriverClassName(driverClassName);
//
//        //configuration
//        datasource.setInitialSize(initialSize);
//        datasource.setMinIdle(minIdle);
//        datasource.setMaxActive(maxActive);
//        datasource.setMaxWait(maxWait);
//        datasource.setTimeBetweenEvictionRunsMillis(timeBetweenEvictionRunsMillis);
//        datasource.setMinEvictableIdleTimeMillis(minEvictableIdleTimeMillis);
//        datasource.setValidationQuery(validationQuery);
//        datasource.setTestWhileIdle(testWhileIdle);
//        datasource.setTestOnBorrow(testOnBorrow);
//        datasource.setTestOnReturn(testOnReturn);
//        datasource.setPoolPreparedStatements(poolPreparedStatements);
//        datasource.setMaxPoolPreparedStatementPerConnectionSize(maxPoolPreparedStatementPerConnectionSize);
//        datasource.setUseGlobalDataSourceStat(useGlobalDataSourceStat);
//        try {
//            datasource.setFilters(filters);
//        } catch (SQLException e) {
//            System.err.println("druid configuration initialization filter: " + e);
//        }
//        datasource.setConnectionProperties(connectionProperties);
//        return datasource;
//    }
//
//    @Bean
//    public DataSourceTransactionManager DataSourceTransactionManager(DataSource dataSource) {
//        DataSourceTransactionManager dataSourceTransactionManager = new DataSourceTransactionManager(dataSource);
//        return dataSourceTransactionManager;
//    }
//
//    /**
//     * 根据数据源创建SqlSessionFactory
//     */
//    @Bean
//    public SqlSessionFactory sqlSessionFactory(DataSource ds) throws Exception {
//        SqlSessionFactoryBean sqlSessionFactoryBean = new SqlSessionFactoryBean();
//        sqlSessionFactoryBean.setDataSource(ds);
////        Interceptor[] plugins = new Interceptor[]{pageHelper(), catInterceptor()};
////        sqlSessionFactoryBean.setPlugins(plugins);
//        PathMatchingResourcePatternResolver resolver = new PathMatchingResourcePatternResolver();
//
//        String typeAliasesPackage = env.getProperty("mybatis.typeAliasesPackage");
//        //typeAliasesPackage=setTypeAliasesPackage(typeAliasesPackage);
//        sqlSessionFactoryBean.setTypeAliasesPackage(typeAliasesPackage);//指定基包
//
//        sqlSessionFactoryBean.setMapperLocations(resolver.getResources(env.getProperty("mybatis.mapperLocations")));
//        return sqlSessionFactoryBean.getObject();
//    }
//
////    @Bean
////    public CatMybatisPlugin catInterceptor() {
////        return new CatMybatisPlugin();
////    }
////
////    @Bean
////    public PageHelper pageHelper() {
////        PageHelper pageHelper = new PageHelper();
////        Properties p = new Properties();
////        p.setProperty("offsetAsPageNum", "true");
////        p.setProperty("rowBoundsWithCount", "true");
////        p.setProperty("reasonable", "true");
////        p.setProperty("helper-dialect", env.getProperty("datasource.dialect"));
////        pageHelper.setProperties(p);
////        return pageHelper;
////    }
//
//}
