package com.trust.ywx.customer.dao;

import com.trust.ywx.customer.common.enu.TempFirmStatusEnum;
import com.trust.ywx.customer.dao.mapper.FirmInfoTempMapper;
import com.trust.ywx.customer.dao.po.FirmInfoTemp;
import com.trust.ywx.customer.dao.po.FirmInfoTempExample;
import org.springframework.stereotype.Repository;

import javax.annotation.Resource;
import java.util.List;

/**
 * <pre></pre>
 *
 * @文件名称： AuditFirmDao.java
 * @包 路  径： com.trust.ywx.customer.dao
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/21 11:40
 * @Modify：
 */
@Repository
public class TempFirmDao {
    @Resource
    FirmInfoTempMapper tempMapper;

    public FirmInfoTemp getByClientId(String clientId){
        FirmInfoTempExample example = new FirmInfoTempExample();
        example.createCriteria().andClientIdEqualTo(clientId);
        return tempMapper.selectOneByExample(example);
    }

    public int auditPass(String clientId){
        // 将临时客户修改为已审核！
        FirmInfoTempExample example = new FirmInfoTempExample();
        example.createCriteria().andClientIdEqualTo(clientId).
                andFirmStatusEqualTo(TempFirmStatusEnum.TEMP_UNAUTHEN.getCode()+"");

        FirmInfoTemp record = new FirmInfoTemp();
        record.setFirmStatus(TempFirmStatusEnum.TEMP_PASS.getCode()+"");
        return tempMapper.updateByExampleSelective(record,example);
    }

    public int auditReject(String clientId){
        // 将临时客户修改为审核拒绝！
        FirmInfoTempExample example = new FirmInfoTempExample();
        example.createCriteria().andClientIdEqualTo(clientId).
                andFirmStatusEqualTo(TempFirmStatusEnum.TEMP_UNAUTHEN.getCode()+"");

        FirmInfoTemp record = new FirmInfoTemp();
        record.setFirmStatus(TempFirmStatusEnum.TEMP_REFUSE.getCode()+"");
        return tempMapper.updateByExampleSelective(record,example);
    }

    public List<FirmInfoTemp> getListByFirmName(String firmName) {
        FirmInfoTempExample example = new FirmInfoTempExample();
        example.createCriteria().andFirmNameEqualTo(firmName);
        return tempMapper.selectByExample(example);
    }

    public int insert(FirmInfoTemp temp) {
        temp.setCreateTime(null);
        temp.setUpdateTime(null);
        return tempMapper.insertSelective(temp);
    }
    public int update(FirmInfoTemp temp) {
        temp.setUpdateTime(null);
        FirmInfoTempExample example = new FirmInfoTempExample();
        example.createCriteria().andClientIdEqualTo(temp.getClientId());
        return tempMapper.updateByExampleSelective(temp,example);
    }
}
