package com.trust.ywx.customer.dao.po;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import lombok.Data;

/**
 * Table: firm_group
 */
@Data
public class FirmGroup implements Serializable {
    /**
     * 唯一标识
     *
     * Table:     firm_group
     * Column:    uniqueId
     * Nullable:  false
     */
    private String uniqueid;

    /**
     * Table:     firm_group
     * Column:    group_name
     * Nullable:  false
     */
    private String groupName;

    /**
     * Table:     firm_group
     * Column:    group_num
     * Nullable:  false
     */
    private String groupId;

    /**
     * Table:     firm_group
     * Column:    firm_id
     * Nullable:  false
     */
    private String firmId;

    /**
     * 1组长 2组员
     *
     * Table:     firm_group
     * Column:    firm_role
     * Nullable:  false
     */
    private Integer firmRole;

    /**
     * Table:     firm_group
     * Column:    create_time
     * Nullable:  false
     */
    private Date createTime;

    /**
     * 1已删除  0未删除
     *
     * Table:     firm_group
     * Column:    is_del
     * Nullable:  true
     */
    private Integer isDel;

    private static final long serialVersionUID = 1L;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", uniqueid=").append(uniqueid);
        sb.append(", groupName=").append(groupName);
        sb.append(", groupId=").append(groupId);
        sb.append(", firmId=").append(firmId);
        sb.append(", firmRole=").append(firmRole);
        sb.append(", createTime=").append(createTime);
        sb.append(", isDel=").append(isDel);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public static FirmGroup.Builder builder() {
        return new FirmGroup.Builder();
    }

    public static class Builder {
        private FirmGroup obj;

        public Builder() {
            this.obj = new FirmGroup();
        }

        public Builder uniqueid(String uniqueid) {
            obj.setUniqueid(uniqueid);
            return this;
        }

        public Builder groupName(String groupName) {
            obj.setGroupName(groupName);
            return this;
        }

        public Builder groupId(String groupId) {
            obj.setGroupId(groupId);
            return this;
        }

        public Builder firmId(String firmId) {
            obj.setFirmId(firmId);
            return this;
        }

        public Builder firmRole(Integer firmRole) {
            obj.setFirmRole(firmRole);
            return this;
        }

        public Builder createTime(Date createTime) {
            obj.setCreateTime(createTime);
            return this;
        }

        public Builder isDel(Integer isDel) {
            obj.setIsDel(isDel);
            return this;
        }

        public FirmGroup build() {
            return this.obj;
        }
    }

    public enum Column {
        uniqueid("uniqueId", "uniqueid", "VARCHAR", false),
        groupName("group_name", "groupName", "VARCHAR", false),
        groupId("group_num", "groupId", "VARCHAR", false),
        firmId("firm_id", "firmId", "VARCHAR", false),
        firmRole("firm_role", "firmRole", "INTEGER", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        isDel("is_del", "isDel", "INTEGER", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}