package com.trust.ywx.customer.dao.po;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import lombok.Data;

/**
 * Table: firm_info
 */
@Data
public class FirmInfo implements Serializable {
    /**
     * 厂商的唯一标识ID
     *
     * Table:     firm_info
     * Column:    uniqueid
     * Nullable:  false
     */
    private String uniqueid;

    /**
     * 第三方应用标识
     *
     * Table:     firm_info
     * Column:    client_id
     * Nullable:  false
     */
    private String clientId;

    /**
     * 客户联系人
     *
     * Table:     firm_info
     * Column:    firm_person
     * Nullable:  false
     */
    private String firmPerson;

    /**
     * 第三方应用APP_SECRET
     *
     * Table:     firm_info
     * Column:    app_secret
     * Nullable:  false
     */
    private String appSecret;

    /**
     * 第三方应用厂商名称
     *
     * Table:     firm_info
     * Column:    firm_name
     * Nullable:  false
     */
    private String firmName;

    /**
     * 第三方厂商联系电话
     *
     * Table:     firm_info
     * Column:    firm_phone
     * Nullable:  false
     */
    private String firmPhone;

    /**
     * 证书算法 RSA/SM2
     *
     * Table:     firm_info
     * Column:    cert_alg
     * Nullable:  false
     */
    private String certAlg;

    /**
     * 第三方厂商联系地址
     *
     * Table:     firm_info
     * Column:    firm_address
     * Nullable:  false
     */
    private String firmAddress;

    /**
     * 第三方厂商描述
     *
     * Table:     firm_info
     * Column:    note
     * Nullable:  false
     */
    private String note;

    /**
     * 第三方厂商邮箱
     *
     * Table:     firm_info
     * Column:    firm_email
     * Nullable:  true
     */
    private String firmEmail;

    /**
     * 第三方厂商状态
     *
     * Table:     firm_info
     * Column:    status
     * Nullable:  true
     */
    private Integer status;

    /**
     * 企业组织机构号
     *
     * Table:     firm_info
     * Column:    client_org_code
     * Nullable:  true
     */
    private String clientOrgCode;

    /**
     * 信步云appid
     *
     * Table:     firm_info
     * Column:    mssp_appid
     * Nullable:  true
     */
    private String msspAppid;

    /**
     * 证书发放厂家
     *
     * Table:     firm_info
     * Column:    cert_agency
     * Nullable:  true
     */
    private String certAgency;

    /**
     * 0 手动制章 1 自动制章
     *
     * Table:     firm_info
     * Column:    stamp_type
     * Nullable:  true
     */
    private String stampType;

    /**
     * 制章名称
     *
     * Table:     firm_info
     * Column:    stamp_name
     * Nullable:  true
     */
    private String stampName;

    /**
     * 外键id
     *
     * Table:     firm_info
     * Column:    open_id
     * Nullable:  true
     */
    private String openId;

    /**
     * 审核完成之后是否发送短信提示
     *
     * Table:     firm_info
     * Column:    send_sms
     * Nullable:  true
     */
    private String sendSms;

    /**
     * 销售人员id
     *
     * Table:     firm_info
     * Column:    sale_person_id
     * Nullable:  true
     */
    private String salePersonId;

    /**
     * 技术支持
     *
     * Table:     firm_info
     * Column:    tech_person_id
     * Nullable:  true
     */
    private String techPersonId;

    /**
     * 创建
     *
     * Table:     firm_info
     * Column:    create_time
     * Nullable:  true
     */
    private Date createTime;

    /**
     * 修改时间
     *
     * Table:     firm_info
     * Column:    update_time
     * Nullable:  true
     */
    private Date updateTime;

    /**
     * 代理厂商id
     *
     * Table:     firm_info
     * Column:    agent_client_id
     * Nullable:  true
     */
    private String agentClientId;

    /**
     * 代理商销售
     *
     * Table:     firm_info
     * Column:    agent_sale_id
     * Nullable:  true
     */
    private String agentSaleId;

    /**
     * Table:     firm_info
     * Column:    ca_channel
     * Nullable:  true
     */
    private Integer caChannel;

    /**
     * 1正常 2试用  3消亡
     *
     * Table:     firm_info
     * Column:    project_status
     * Nullable:  true
     */
    private Integer projectStatus;

    /**
     * 数字认证运营平台app_id
     *
     * Table:     firm_info
     * Column:    plat_app_id
     * Nullable:  true
     */
    private Integer platAppId;

    /**
     * 第三方应用证书
     *
     * Table:     firm_info
     * Column:    app_cert
     * Nullable:  true
     */
    private String appCert;

    /**
     * 第三方厂商图标
     *
     * Table:     firm_info
     * Column:    app_icon
     * Nullable:  true
     */
    private String appIcon;

    private static final long serialVersionUID = 1L;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", uniqueid=").append(uniqueid);
        sb.append(", clientId=").append(clientId);
        sb.append(", firmPerson=").append(firmPerson);
        sb.append(", appSecret=").append(appSecret);
        sb.append(", firmName=").append(firmName);
        sb.append(", firmPhone=").append(firmPhone);
        sb.append(", certAlg=").append(certAlg);
        sb.append(", firmAddress=").append(firmAddress);
        sb.append(", note=").append(note);
        sb.append(", firmEmail=").append(firmEmail);
        sb.append(", status=").append(status);
        sb.append(", clientOrgCode=").append(clientOrgCode);
        sb.append(", msspAppid=").append(msspAppid);
        sb.append(", certAgency=").append(certAgency);
        sb.append(", stampType=").append(stampType);
        sb.append(", stampName=").append(stampName);
        sb.append(", openId=").append(openId);
        sb.append(", sendSms=").append(sendSms);
        sb.append(", salePersonId=").append(salePersonId);
        sb.append(", techPersonId=").append(techPersonId);
        sb.append(", createTime=").append(createTime);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", agentClientId=").append(agentClientId);
        sb.append(", agentSaleId=").append(agentSaleId);
        sb.append(", caChannel=").append(caChannel);
        sb.append(", projectStatus=").append(projectStatus);
        sb.append(", platAppId=").append(platAppId);
        sb.append(", appCert=").append(appCert);
        sb.append(", appIcon=").append(appIcon);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public static FirmInfo.Builder builder() {
        return new FirmInfo.Builder();
    }

    public static class Builder {
        private FirmInfo obj;

        public Builder() {
            this.obj = new FirmInfo();
        }

        public Builder uniqueid(String uniqueid) {
            obj.setUniqueid(uniqueid);
            return this;
        }

        public Builder clientId(String clientId) {
            obj.setClientId(clientId);
            return this;
        }

        public Builder firmPerson(String firmPerson) {
            obj.setFirmPerson(firmPerson);
            return this;
        }

        public Builder appSecret(String appSecret) {
            obj.setAppSecret(appSecret);
            return this;
        }

        public Builder firmName(String firmName) {
            obj.setFirmName(firmName);
            return this;
        }

        public Builder firmPhone(String firmPhone) {
            obj.setFirmPhone(firmPhone);
            return this;
        }

        public Builder certAlg(String certAlg) {
            obj.setCertAlg(certAlg);
            return this;
        }

        public Builder firmAddress(String firmAddress) {
            obj.setFirmAddress(firmAddress);
            return this;
        }

        public Builder note(String note) {
            obj.setNote(note);
            return this;
        }

        public Builder firmEmail(String firmEmail) {
            obj.setFirmEmail(firmEmail);
            return this;
        }

        public Builder status(Integer status) {
            obj.setStatus(status);
            return this;
        }

        public Builder clientOrgCode(String clientOrgCode) {
            obj.setClientOrgCode(clientOrgCode);
            return this;
        }

        public Builder msspAppid(String msspAppid) {
            obj.setMsspAppid(msspAppid);
            return this;
        }

        public Builder certAgency(String certAgency) {
            obj.setCertAgency(certAgency);
            return this;
        }

        public Builder stampType(String stampType) {
            obj.setStampType(stampType);
            return this;
        }

        public Builder stampName(String stampName) {
            obj.setStampName(stampName);
            return this;
        }

        public Builder openId(String openId) {
            obj.setOpenId(openId);
            return this;
        }

        public Builder sendSms(String sendSms) {
            obj.setSendSms(sendSms);
            return this;
        }

        public Builder salePersonId(String salePersonId) {
            obj.setSalePersonId(salePersonId);
            return this;
        }

        public Builder techPersonId(String techPersonId) {
            obj.setTechPersonId(techPersonId);
            return this;
        }

        public Builder createTime(Date createTime) {
            obj.setCreateTime(createTime);
            return this;
        }

        public Builder updateTime(Date updateTime) {
            obj.setUpdateTime(updateTime);
            return this;
        }

        public Builder agentClientId(String agentClientId) {
            obj.setAgentClientId(agentClientId);
            return this;
        }

        public Builder agentSaleId(String agentSaleId) {
            obj.setAgentSaleId(agentSaleId);
            return this;
        }

        public Builder caChannel(Integer caChannel) {
            obj.setCaChannel(caChannel);
            return this;
        }

        public Builder projectStatus(Integer projectStatus) {
            obj.setProjectStatus(projectStatus);
            return this;
        }

        public Builder platAppId(Integer platAppId) {
            obj.setPlatAppId(platAppId);
            return this;
        }

        public Builder appCert(String appCert) {
            obj.setAppCert(appCert);
            return this;
        }

        public Builder appIcon(String appIcon) {
            obj.setAppIcon(appIcon);
            return this;
        }

        public FirmInfo build() {
            return this.obj;
        }
    }

    public enum Column {
        uniqueid("uniqueid", "uniqueid", "VARCHAR", false),
        clientId("client_id", "clientId", "VARCHAR", false),
        firmPerson("firm_person", "firmPerson", "VARCHAR", false),
        appSecret("app_secret", "appSecret", "VARCHAR", false),
        firmName("firm_name", "firmName", "VARCHAR", false),
        firmPhone("firm_phone", "firmPhone", "VARCHAR", false),
        certAlg("cert_alg", "certAlg", "VARCHAR", false),
        firmAddress("firm_address", "firmAddress", "VARCHAR", false),
        note("note", "note", "VARCHAR", false),
        firmEmail("firm_email", "firmEmail", "VARCHAR", false),
        status("status", "status", "INTEGER", false),
        clientOrgCode("client_org_code", "clientOrgCode", "VARCHAR", false),
        msspAppid("mssp_appid", "msspAppid", "VARCHAR", false),
        certAgency("cert_agency", "certAgency", "VARCHAR", false),
        stampType("stamp_type", "stampType", "CHAR", false),
        stampName("stamp_name", "stampName", "VARCHAR", false),
        openId("open_id", "openId", "VARCHAR", false),
        sendSms("send_sms", "sendSms", "VARCHAR", false),
        salePersonId("sale_person_id", "salePersonId", "VARCHAR", false),
        techPersonId("tech_person_id", "techPersonId", "VARCHAR", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        agentClientId("agent_client_id", "agentClientId", "VARCHAR", false),
        agentSaleId("agent_sale_id", "agentSaleId", "VARCHAR", false),
        caChannel("ca_channel", "caChannel", "INTEGER", false),
        projectStatus("project_status", "projectStatus", "INTEGER", false),
        platAppId("plat_app_id", "platAppId", "INTEGER", false),
        appCert("app_cert", "appCert", "LONGVARCHAR", false),
        appIcon("app_icon", "appIcon", "LONGVARCHAR", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}