package com.trust.ywx.customer.dao.po;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import lombok.Data;

/**
 * Table: firm_info_extend
 */
@Data
public class FirmInfoExtend implements Serializable {
    /**
     * 主键
     *
     * Table:     firm_info_extend
     * Column:    uniqueid
     * Nullable:  false
     */
    private String uniqueid;

    /**
     * 厂商标识
     *
     * Table:     firm_info_extend
     * Column:    client_id
     * Nullable:  true
     */
    private String clientId;

    /**
     * Table:     firm_info_extend
     * Column:    prop_name
     * Nullable:  true
     */
    private String propName;

    /**
     * Table:     firm_info_extend
     * Column:    prop_value
     * Nullable:  true
     */
    private String propValue;

    private static final long serialVersionUID = 1L;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", uniqueid=").append(uniqueid);
        sb.append(", clientId=").append(clientId);
        sb.append(", propName=").append(propName);
        sb.append(", propValue=").append(propValue);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public static FirmInfoExtend.Builder builder() {
        return new FirmInfoExtend.Builder();
    }

    public static class Builder {
        private FirmInfoExtend obj;

        public Builder() {
            this.obj = new FirmInfoExtend();
        }

        public Builder uniqueid(String uniqueid) {
            obj.setUniqueid(uniqueid);
            return this;
        }

        public Builder clientId(String clientId) {
            obj.setClientId(clientId);
            return this;
        }

        public Builder propName(String propName) {
            obj.setPropName(propName);
            return this;
        }

        public Builder propValue(String propValue) {
            obj.setPropValue(propValue);
            return this;
        }

        public FirmInfoExtend build() {
            return this.obj;
        }
    }

    public enum Column {
        uniqueid("uniqueid", "uniqueid", "VARCHAR", false),
        clientId("client_id", "clientId", "VARCHAR", false),
        propName("prop_name", "propName", "VARCHAR", false),
        propValue("prop_value", "propValue", "VARCHAR", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}