package com.trust.ywx.customer.dao.po;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import lombok.Data;

/**
 * Table: firm_info_temp
 */
@Data
public class FirmInfoTemp implements Serializable {
    /**
     * 唯一主键
     *
     * Table:     firm_info_temp
     * Column:    uniqueid
     * Nullable:  false
     */
    private String uniqueid;

    /**
     * 外键ID
     *
     * Table:     firm_info_temp
     * Column:    open_id
     * Nullable:  true
     */
    private String openId;

    /**
     * 企业营业执照
     *
     * Table:     firm_info_temp
     * Column:    business_license_url
     * Nullable:  true
     */
    private String businessLicenseUrl;

    /**
     * 组织机构代码照片
     *
     * Table:     firm_info_temp
     * Column:    org_code_url
     * Nullable:  true
     */
    private String orgCodeUrl;

    /**
     * 法人身份证正面
     *
     * Table:     firm_info_temp
     * Column:    juridical_idcard_front_url
     * Nullable:  true
     */
    private String juridicalIdcardFrontUrl;

    /**
     * 法人身份证背面
     *
     * Table:     firm_info_temp
     * Column:    juridical_idcard_back_url
     * Nullable:  true
     */
    private String juridicalIdcardBackUrl;

    /**
     * 法人临时身份证
     *
     * Table:     firm_info_temp
     * Column:    juridical_tmp_id_url
     * Nullable:  true
     */
    private String juridicalTmpIdUrl;

    /**
     * 企业名称
     *
     * Table:     firm_info_temp
     * Column:    firm_name
     * Nullable:  false
     */
    private String firmName;

    /**
     * 工商注册号
     *
     * Table:     firm_info_temp
     * Column:    firm_bus_reg_num
     * Nullable:  true
     */
    private String firmBusRegNum;

    /**
     * 社会信用代码
     *
     * Table:     firm_info_temp
     * Column:    firm_soc_cre_code
     * Nullable:  true
     */
    private String firmSocCreCode;

    /**
     * 企业地址
     *
     * Table:     firm_info_temp
     * Column:    firm_addr
     * Nullable:  true
     */
    private String firmAddress;

    /**
     * Table:     firm_info_temp
     * Column:    firm_org_code
     * Nullable:  true
     */
    private String firmOrgCode;

    /**
     * 税务登记证号
     *
     * Table:     firm_info_temp
     * Column:    firm_tax_reg_cert_code
     * Nullable:  true
     */
    private String firmTaxRegCertCode;

    /**
     * 经营范围
     *
     * Table:     firm_info_temp
     * Column:    firm_bus_scope
     * Nullable:  true
     */
    private String firmBusScope;

    /**
     * 经营期限
     *
     * Table:     firm_info_temp
     * Column:    firm_bus_time
     * Nullable:  true
     */
    private Date firmBusTime;

    /**
     * 法人归属地
     *
     * Table:     firm_info_temp
     * Column:    juridical_nationality
     * Nullable:  true
     */
    private String juridicalNationality;

    /**
     * 法人姓名
     *
     * Table:     firm_info_temp
     * Column:    juridical_name
     * Nullable:  true
     */
    private String juridicalName;

    /**
     * 法人联系电话
     *
     * Table:     firm_info_temp
     * Column:    juridical_phone
     * Nullable:  true
     */
    private String juridicalPhone;

    /**
     * 法人身份证号
     *
     * Table:     firm_info_temp
     * Column:    juridical_idcard
     * Nullable:  true
     */
    private String juridicalIdcard;

    /**
     * 法人证件有效期
     *
     * Table:     firm_info_temp
     * Column:    juridical_time
     * Nullable:  true
     */
    private Date juridicalTime;

    /**
     * 代理人姓名
     *
     * Table:     firm_info_temp
     * Column:    agent_name
     * Nullable:  true
     */
    private String agentName;

    /**
     * 代理人身份证号
     *
     * Table:     firm_info_temp
     * Column:    agent_idcard
     * Nullable:  true
     */
    private String agentIdcard;

    /**
     * 代理人证件有效期
     *
     * Table:     firm_info_temp
     * Column:    agent_time
     * Nullable:  true
     */
    private Date agentTime;

    /**
     * 企业电话
     *
     * Table:     firm_info_temp
     * Column:    firm_phone
     * Nullable:  true
     */
    private String firmPhone;

    /**
     * 邮箱
     *
     * Table:     firm_info_temp
     * Column:    firm_email
     * Nullable:  true
     */
    private String firmEmail;

    /**
     * 实名认证标识（0：未认证 1：已认证 2：认证不通过 3：认证失败）
     *
     * Table:     firm_info_temp
     * Column:    realname_check
     * Nullable:  false
     */
    private String realnameCheck;

    /**
     * 厂商状态0待审核 1审核通过 2审核拒绝 4删除
     *
     * Table:     firm_info_temp
     * Column:    firm_status
     * Nullable:  false
     */
    private String firmStatus;

    /**
     * 实名认证标识（0：未认证 1：已认证 2：认证不通过 3：认证失败）
     *
     * Table:     firm_info_temp
     * Column:    juridical_realname_check
     * Nullable:  false
     */
    private String juridicalRealnameCheck;

    /**
     * 代理人电话
     *
     * Table:     firm_info_temp
     * Column:    agent_phone
     * Nullable:  true
     */
    private String agentPhone;

    /**
     * 渠道0app 1sdk 2app和sdk
     *
     * Table:     firm_info_temp
     * Column:    channel
     * Nullable:  true
     */
    private String channel;

    /**
     * Table:     firm_info_temp
     * Column:    agent_client_id
     * Nullable:  true
     */
    private String agentClientId;

    /**
     * 代理商销售
     *
     * Table:     firm_info_temp
     * Column:    agent_sale_id
     * Nullable:  true
     */
    private String agentSaleId;

    /**
     * 厂商clientid
     *
     * Table:     firm_info_temp
     * Column:    firm_client_id
     * Nullable:  true
     */
    private String clientId;

    /**
     * Table:     firm_info_temp
     * Column:    create_time
     * Nullable:  true
     */
    private Date createTime;

    /**
     * Table:     firm_info_temp
     * Column:    update_time
     * Nullable:  true
     */
    private Date updateTime;

    /**
     * 厂商联系人
     *
     * Table:     firm_info_temp
     * Column:    firm_person
     * Nullable:  false
     */
    private String firmPerson;

    /**
     * Table:     firm_info_temp
     * Column:    firm_logo
     * Nullable:  true
     */
    private String firmLogo;

    private static final long serialVersionUID = 1L;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", uniqueid=").append(uniqueid);
        sb.append(", openId=").append(openId);
        sb.append(", businessLicenseUrl=").append(businessLicenseUrl);
        sb.append(", orgCodeUrl=").append(orgCodeUrl);
        sb.append(", juridicalIdcardFrontUrl=").append(juridicalIdcardFrontUrl);
        sb.append(", juridicalIdcardBackUrl=").append(juridicalIdcardBackUrl);
        sb.append(", juridicalTmpIdUrl=").append(juridicalTmpIdUrl);
        sb.append(", firmName=").append(firmName);
        sb.append(", firmBusRegNum=").append(firmBusRegNum);
        sb.append(", firmSocCreCode=").append(firmSocCreCode);
        sb.append(", firmAddress=").append(firmAddress);
        sb.append(", firmOrgCode=").append(firmOrgCode);
        sb.append(", firmTaxRegCertCode=").append(firmTaxRegCertCode);
        sb.append(", firmBusScope=").append(firmBusScope);
        sb.append(", firmBusTime=").append(firmBusTime);
        sb.append(", juridicalNationality=").append(juridicalNationality);
        sb.append(", juridicalName=").append(juridicalName);
        sb.append(", juridicalPhone=").append(juridicalPhone);
        sb.append(", juridicalIdcard=").append(juridicalIdcard);
        sb.append(", juridicalTime=").append(juridicalTime);
        sb.append(", agentName=").append(agentName);
        sb.append(", agentIdcard=").append(agentIdcard);
        sb.append(", agentTime=").append(agentTime);
        sb.append(", firmPhone=").append(firmPhone);
        sb.append(", firmEmail=").append(firmEmail);
        sb.append(", realnameCheck=").append(realnameCheck);
        sb.append(", firmStatus=").append(firmStatus);
        sb.append(", juridicalRealnameCheck=").append(juridicalRealnameCheck);
        sb.append(", agentPhone=").append(agentPhone);
        sb.append(", channel=").append(channel);
        sb.append(", agentClientId=").append(agentClientId);
        sb.append(", agentSaleId=").append(agentSaleId);
        sb.append(", clientId=").append(clientId);
        sb.append(", createTime=").append(createTime);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", firmPerson=").append(firmPerson);
        sb.append(", firmLogo=").append(firmLogo);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public static FirmInfoTemp.Builder builder() {
        return new FirmInfoTemp.Builder();
    }

    public static class Builder {
        private FirmInfoTemp obj;

        public Builder() {
            this.obj = new FirmInfoTemp();
        }

        public Builder uniqueid(String uniqueid) {
            obj.setUniqueid(uniqueid);
            return this;
        }

        public Builder openId(String openId) {
            obj.setOpenId(openId);
            return this;
        }

        public Builder businessLicenseUrl(String businessLicenseUrl) {
            obj.setBusinessLicenseUrl(businessLicenseUrl);
            return this;
        }

        public Builder orgCodeUrl(String orgCodeUrl) {
            obj.setOrgCodeUrl(orgCodeUrl);
            return this;
        }

        public Builder juridicalIdcard(String juridicalIdcard) {
            obj.setJuridicalIdcard(juridicalIdcard);
            return this;
        }

        public Builder juridicalIdcardFrontUrl(String juridicalIdcardFrontUrl) {
            obj.setJuridicalIdcardFrontUrl(juridicalIdcardFrontUrl);
            return this;
        }

        public Builder juridicalIdcardBackUrl(String juridicalIdcardBackUrl) {
            obj.setJuridicalIdcardBackUrl(juridicalIdcardBackUrl);
            return this;
        }

        public Builder juridicalTmpIdUrl(String juridicalTmpIdUrl) {
            obj.setJuridicalTmpIdUrl(juridicalTmpIdUrl);
            return this;
        }

        public Builder firmName(String firmName) {
            obj.setFirmName(firmName);
            return this;
        }

        public Builder firmBusRegNum(String firmBusRegNum) {
            obj.setFirmBusRegNum(firmBusRegNum);
            return this;
        }

        public Builder firmSocCreCode(String firmSocCreCode) {
            obj.setFirmSocCreCode(firmSocCreCode);
            return this;
        }

        public Builder firmAddress(String firmAddress) {
            obj.setFirmAddress(firmAddress);
            return this;
        }

        public Builder firmOrgCode(String firmOrgCode) {
            obj.setFirmOrgCode(firmOrgCode);
            return this;
        }

        public Builder firmTaxRegCertCode(String firmTaxRegCertCode) {
            obj.setFirmTaxRegCertCode(firmTaxRegCertCode);
            return this;
        }

        public Builder firmBusScope(String firmBusScope) {
            obj.setFirmBusScope(firmBusScope);
            return this;
        }

        public Builder firmBusTime(Date firmBusTime) {
            obj.setFirmBusTime(firmBusTime);
            return this;
        }

        public Builder juridicalNationality(String juridicalNationality) {
            obj.setJuridicalNationality(juridicalNationality);
            return this;
        }

        public Builder juridicalName(String juridicalName) {
            obj.setJuridicalName(juridicalName);
            return this;
        }

        public Builder juridicalPhone(String juridicalPhone) {
            obj.setJuridicalPhone(juridicalPhone);
            return this;
        }

        public Builder juridicalTime(Date juridicalTime) {
            obj.setJuridicalTime(juridicalTime);
            return this;
        }

        public Builder agentName(String agentName) {
            obj.setAgentName(agentName);
            return this;
        }

        public Builder agentIdcard(String agentIdcard) {
            obj.setAgentIdcard(agentIdcard);
            return this;
        }

        public Builder agentTime(Date agentTime) {
            obj.setAgentTime(agentTime);
            return this;
        }

        public Builder firmPhone(String firmPhone) {
            obj.setFirmPhone(firmPhone);
            return this;
        }

        public Builder firmEmail(String firmEmail) {
            obj.setFirmEmail(firmEmail);
            return this;
        }

        public Builder realnameCheck(String realnameCheck) {
            obj.setRealnameCheck(realnameCheck);
            return this;
        }

        public Builder firmStatus(String firmStatus) {
            obj.setFirmStatus(firmStatus);
            return this;
        }

        public Builder juridicalRealnameCheck(String juridicalRealnameCheck) {
            obj.setJuridicalRealnameCheck(juridicalRealnameCheck);
            return this;
        }

        public Builder agentPhone(String agentPhone) {
            obj.setAgentPhone(agentPhone);
            return this;
        }

        public Builder channel(String channel) {
            obj.setChannel(channel);
            return this;
        }

        public Builder agentClientId(String agentClientId) {
            obj.setAgentClientId(agentClientId);
            return this;
        }

        public Builder agentSaleId(String agentSaleId) {
            obj.setAgentSaleId(agentSaleId);
            return this;
        }

        public Builder clientId(String clientId) {
            obj.setClientId(clientId);
            return this;
        }

        public Builder createTime(Date createTime) {
            obj.setCreateTime(createTime);
            return this;
        }

        public Builder updateTime(Date updateTime) {
            obj.setUpdateTime(updateTime);
            return this;
        }

        public Builder firmPerson(String firmPerson) {
            obj.setFirmPerson(firmPerson);
            return this;
        }

        public Builder firmLogo(String firmLogo) {
            obj.setFirmLogo(firmLogo);
            return this;
        }

        public FirmInfoTemp build() {
            return this.obj;
        }
    }

    public enum Column {
        uniqueid("uniqueid", "uniqueid", "VARCHAR", false),
        openId("open_id", "openId", "VARCHAR", false),
        businessLicenseUrl("business_license_url", "businessLicenseUrl", "VARCHAR", false),
        orgCodeUrl("org_code_url", "orgCodeUrl", "VARCHAR", false),
        juridicalIdcardFrontUrl("juridical_idcard_front_url", "juridicalIdcardFrontUrl", "VARCHAR", false),
        juridicalIdcardBackUrl("juridical_idcard_back_url", "juridicalIdcardBackUrl", "VARCHAR", false),
        juridicalTmpIdUrl("juridical_tmp_id_url", "juridicalTmpIdUrl", "VARCHAR", false),
        firmName("firm_name", "firmName", "VARCHAR", false),
        firmBusRegNum("firm_bus_reg_num", "firmBusRegNum", "VARCHAR", false),
        firmSocCreCode("firm_soc_cre_code", "firmSocCreCode", "VARCHAR", false),
        firmAddress("firm_addr", "firmAddress", "VARCHAR", false),
        firmOrgCode("firm_org_code", "firmOrgCode", "VARCHAR", false),
        firmTaxRegCertCode("firm_tax_reg_cert_code", "firmTaxRegCertCode", "VARCHAR", false),
        firmBusScope("firm_bus_scope", "firmBusScope", "VARCHAR", false),
        firmBusTime("firm_bus_time", "firmBusTime", "TIMESTAMP", false),
        juridicalNationality("juridical_nationality", "juridicalNationality", "VARCHAR", false),
        juridicalName("juridical_name", "juridicalName", "VARCHAR", false),
        juridicalPhone("juridical_phone", "juridicalPhone", "VARCHAR", false),
        juridicalIdcard("juridical_idcard", "juridicalIdcard", "VARCHAR", false),
        juridicalTime("juridical_time", "juridicalTime", "TIMESTAMP", false),
        agentName("agent_name", "agentName", "VARCHAR", false),
        agentIdcard("agent_idcard", "agentIdcard", "VARCHAR", false),
        agentTime("agent_time", "agentTime", "TIMESTAMP", false),
        firmPhone("firm_phone", "firmPhone", "VARCHAR", false),
        firmEmail("firm_email", "firmEmail", "VARCHAR", false),
        realnameCheck("realname_check", "realnameCheck", "CHAR", false),
        firmStatus("firm_status", "firmStatus", "VARCHAR", false),
        juridicalRealnameCheck("juridical_realname_check", "juridicalRealnameCheck", "CHAR", false),
        agentPhone("agent_phone", "agentPhone", "VARCHAR", false),
        channel("channel", "channel", "VARCHAR", false),
        agentClientId("agent_client_id", "agentClientId", "VARCHAR", false),
        agentSaleId("agent_sale_id", "agentSaleId", "VARCHAR", false),
        clientId("firm_client_id", "clientId", "VARCHAR", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        firmPerson("firm_person", "firmPerson", "VARCHAR", false),
        firmLogo("firm_logo", "firmLogo", "LONGVARCHAR", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}