package com.trust.ywx.customer.dao.po;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import lombok.Data;

/**
 * Table: firm_oauth_token
 */
@Data
public class FirmOauthToken implements Serializable {
    /**
     * 主键
     *
     * Table:     firm_oauth_token
     * Column:    uniqueid
     * Nullable:  false
     */
    private String uniqueid;

    /**
     * 厂商唯一标识
     *
     * Table:     firm_oauth_token
     * Column:    client_id
     * Nullable:  false
     */
    private String clientId;

    /**
     * 授权信息
     *
     * Table:     firm_oauth_token
     * Column:    access_token
     * Nullable:  false
     */
    private String accessToken;

    /**
     * 授权信息过期时间（秒）
     *
     * Table:     firm_oauth_token
     * Column:    access_token_expires
     * Nullable:  false
     */
    private Integer accessTokenExpires;

    /**
     * 授权请求次数
     *
     * Table:     firm_oauth_token
     * Column:    call_num
     * Nullable:  false
     */
    private Integer callNum;

    /**
     * Table:     firm_oauth_token
     * Column:    scope
     * Nullable:  true
     */
    private String scope;

    /**
     * 创建时间
     *
     * Table:     firm_oauth_token
     * Column:    create_time
     * Nullable:  false
     */
    private Date createTime;

    /**
     * 更新时间
     *
     * Table:     firm_oauth_token
     * Column:    update_time
     * Nullable:  true
     */
    private Date updateTime;

    /**
     * Table:     firm_oauth_token
     * Column:    app_secret
     * Nullable:  false
     */
    private String appSecret;

    private static final long serialVersionUID = 1L;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", uniqueid=").append(uniqueid);
        sb.append(", clientId=").append(clientId);
        sb.append(", accessToken=").append(accessToken);
        sb.append(", accessTokenExpires=").append(accessTokenExpires);
        sb.append(", callNum=").append(callNum);
        sb.append(", scope=").append(scope);
        sb.append(", createTime=").append(createTime);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", appSecret=").append(appSecret);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public static FirmOauthToken.Builder builder() {
        return new FirmOauthToken.Builder();
    }

    public static class Builder {
        private FirmOauthToken obj;

        public Builder() {
            this.obj = new FirmOauthToken();
        }

        public Builder uniqueid(String uniqueid) {
            obj.setUniqueid(uniqueid);
            return this;
        }

        public Builder clientId(String clientId) {
            obj.setClientId(clientId);
            return this;
        }

        public Builder accessToken(String accessToken) {
            obj.setAccessToken(accessToken);
            return this;
        }

        public Builder accessTokenExpires(Integer accessTokenExpires) {
            obj.setAccessTokenExpires(accessTokenExpires);
            return this;
        }

        public Builder callNum(Integer callNum) {
            obj.setCallNum(callNum);
            return this;
        }

        public Builder scope(String scope) {
            obj.setScope(scope);
            return this;
        }

        public Builder createTime(Date createTime) {
            obj.setCreateTime(createTime);
            return this;
        }

        public Builder updateTime(Date updateTime) {
            obj.setUpdateTime(updateTime);
            return this;
        }

        public Builder appSecret(String appSecret) {
            obj.setAppSecret(appSecret);
            return this;
        }

        public FirmOauthToken build() {
            return this.obj;
        }
    }

    public enum Column {
        uniqueid("uniqueid", "uniqueid", "CHAR", false),
        clientId("client_id", "clientId", "CHAR", false),
        accessToken("access_token", "accessToken", "CHAR", false),
        accessTokenExpires("access_token_expires", "accessTokenExpires", "INTEGER", false),
        callNum("call_num", "callNum", "INTEGER", false),
        scope("scope", "scope", "VARCHAR", false),
        createTime("create_time", "createTime", "TIMESTAMP", false),
        updateTime("update_time", "updateTime", "TIMESTAMP", false),
        appSecret("app_secret", "appSecret", "VARCHAR", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}