package com.trust.ywx.customer.dao.po;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import lombok.Data;

/**
 * Table: firm_usercert_channel
 */
@Data
public class FirmUsercertChannel implements Serializable {
    /**
     * 主键id
     *
     * Table:     firm_usercert_channel
     * Column:    uniqueid
     * Nullable:  false
     */
    private String uniqueid;

    /**
     * 证书渠道对应厂商id
     *
     * Table:     firm_usercert_channel
     * Column:    clientid
     * Nullable:  false
     */
    private String clientid;

    /**
     * 厂商表主键
     *
     * Table:     firm_usercert_channel
     * Column:    firm_id
     * Nullable:  false
     */
    private String firmId;

    /**
     * 渠道类型 0 app 1 sdk
     *
     * Table:     firm_usercert_channel
     * Column:    channel_type
     * Nullable:  false
     */
    private Integer channelType;

    private static final long serialVersionUID = 1L;

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", uniqueid=").append(uniqueid);
        sb.append(", clientid=").append(clientid);
        sb.append(", firmId=").append(firmId);
        sb.append(", channelType=").append(channelType);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }

    public static FirmUsercertChannel.Builder builder() {
        return new FirmUsercertChannel.Builder();
    }

    public static class Builder {
        private FirmUsercertChannel obj;

        public Builder() {
            this.obj = new FirmUsercertChannel();
        }

        public Builder uniqueid(String uniqueid) {
            obj.setUniqueid(uniqueid);
            return this;
        }

        public Builder clientid(String clientid) {
            obj.setClientid(clientid);
            return this;
        }

        public Builder firmId(String firmId) {
            obj.setFirmId(firmId);
            return this;
        }

        public Builder channelType(Integer channelType) {
            obj.setChannelType(channelType);
            return this;
        }

        public FirmUsercertChannel build() {
            return this.obj;
        }
    }

    public enum Column {
        uniqueid("uniqueid", "uniqueid", "VARCHAR", false),
        clientid("clientid", "clientid", "VARCHAR", false),
        firmId("firm_id", "firmId", "VARCHAR", false),
        channelType("channel_type", "channelType", "BIT", false);

        private static final String BEGINNING_DELIMITER = "\"";

        private static final String ENDING_DELIMITER = "\"";

        private final String column;

        private final boolean isColumnNameDelimited;

        private final String javaProperty;

        private final String jdbcType;

        public String value() {
            return this.column;
        }

        public String getValue() {
            return this.column;
        }

        public String getJavaProperty() {
            return this.javaProperty;
        }

        public String getJdbcType() {
            return this.jdbcType;
        }

        Column(String column, String javaProperty, String jdbcType, boolean isColumnNameDelimited) {
            this.column = column;
            this.javaProperty = javaProperty;
            this.jdbcType = jdbcType;
            this.isColumnNameDelimited = isColumnNameDelimited;
        }

        public String desc() {
            return this.getEscapedColumnName() + " DESC";
        }

        public String asc() {
            return this.getEscapedColumnName() + " ASC";
        }

        public static Column[] excludes(Column ... excludes) {
            ArrayList<Column> columns = new ArrayList<>(Arrays.asList(Column.values()));
            if (excludes != null && excludes.length > 0) {
                columns.removeAll(new ArrayList<>(Arrays.asList(excludes)));
            }
            return columns.toArray(new Column[]{});
        }

        public static Column[] all() {
            return Column.values();
        }

        public String getEscapedColumnName() {
            if (this.isColumnNameDelimited) {
                return new StringBuilder().append(BEGINNING_DELIMITER).append(this.column).append(ENDING_DELIMITER).toString();
            } else {
                return this.column;
            }
        }

        public String getAliasedEscapedColumnName() {
            return this.getEscapedColumnName();
        }
    }
}