package com.trust.ywx.customer.service.filter;


import org.apache.dubbo.common.constants.CommonConstants;
import org.apache.dubbo.common.extension.Activate;
import org.apache.dubbo.common.extension.SPI;
import org.apache.dubbo.common.logger.Logger;
import org.apache.dubbo.common.logger.LoggerFactory;
import org.apache.dubbo.rpc.*;

import java.util.Arrays;
import java.util.List;

/**
 * <pre></pre>
 *
 * @文件名称： DubboCustomerInvokeFilter.java
 * @包 路  径： com.trust.ywx.customer.service.exceptions
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 可信客户的配置属性很多，为了防止业务方频繁调用造成服务端压力，在此增加过滤器，拦截获取配置属性方法，从本地缓存获取并返回。
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/11 21:15
 * @Modify：
 */
@SPI
@Activate(group = {CommonConstants.CONSUMER})
public class DubboCustomerExtendsInvokeFilter implements Filter {
    private final Logger logger = LoggerFactory.getLogger(getClass());

    /**
     * 将客户全量信息缓存在本地，当调用者获取某个配置项时，在此偷梁换柱！
     * key=clientId
     * value=CustomerInfoDto
     */
//    private Map<String, TrustFirmDto> customerInfoMap = new ConcurrentHashMap();

    private static final List<String> filterMethodList = Arrays.asList("getCustomerInfo");
    @Override
    public Result invoke(Invoker<?> invoker, Invocation invocation) throws RpcException {
//        System.out.println("provider ，我进来啦 开始了");
//        logger.info("provider，i'm comming");
//        if(filterMethodList.contains(invocation.getMethodName())){
//            Object[] arguments = invocation.getArguments();
//            /**
//             * 参数不合法时，是否透传？
//             */
//            if(null!=arguments && arguments[0]==null){
//                return invoker.invoke(invocation);
//            }
//            String clientId = (String) arguments[0];
////            TrustFirmDto customer = customerInfoMap.get(clientId);
////            if(customer!=null){
//////                customer.getClass().getMethod(invocation.getMethodName(),"")
////                return new AppResponse(null);
////            }else{
//                //异步刷新
////                refreshCache();
////                System.out.println("aaaaaaaaaaaaaaaaaaaa");
////                customer = new TrustFirmDto();
////                customer.setClientId("我是服务端代码，别特么调用我");
////                customer.setAllowUserBind("111111111111");
////                CompletableFuture b = new CompletableFuture();
////                AsyncRpcResult asyncRpcResult = new AsyncRpcResult(b,invocation);
////                asyncRpcResult.setValue(customer);
////                return asyncRpcResult;
//            }
//        }
        Result r = invoker.invoke(invocation);
        return r;
    }

    /**
     * 定时获取变化的客户配置信息
     * 调用为对外暴露但是已注册的rpc接口
     */
    private void refreshCacheSchedule() {

    }

}
