package com.trust.ywx.customer.service.manager;

import com.trust.ywx.customer.common.model.manager.request.TempFirmParam;
import com.trust.ywx.customer.common.exception.BizException;

/**
 * <pre></pre>
 *
 * @文件名称： FirmManagerService.java
 * @包 路  径： com.trust.ywx.customer.service.manager
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/15 18:55
 * @Modify：
 */
public interface TempFirmManagerService {

    /**
     * 添加临时客户
     * 互联网医院通过开放平台自注册临时客户，会在firm_info_temp表生成client_id
     *
     */
    boolean add(TempFirmParam param) throws BizException;

    /**
     * 更新临时客户
     * @param param
     * @return
     * @throws BizException
     */
    boolean update(TempFirmParam param) throws BizException;

    /**
     * 审核临时客户
     * @param clientId
     * @return
     */
    boolean audit(String clientId) throws BizException;

    /**
     * 拒绝临时客户
     * @param clientId
     * @return
     */
    boolean reject(String clientId) throws BizException;

    /**
     * 删除临时客户
     * @param clientId
     * @return
     */
    boolean delete(String clientId);
}
