package com.trust.ywx.customer.service.query;

import com.fiftyonetrust.common.model.result.PageList;
import com.trust.ywx.customer.common.model.manager.response.TrustFirmDto;
import com.trust.ywx.customer.common.model.query.request.SearchCrmFirmParam;
import com.trust.ywx.customer.common.model.query.request.SearchFirmParam;
import com.trust.ywx.customer.common.model.query.request.SearchTrustFirmParam;
import com.trust.ywx.customer.common.model.manager.response.TempFirmDto;
import com.trust.ywx.customer.common.model.query.response.CrmFirmDto;

import java.util.List;
import java.util.Map;

/**
 * <pre></pre>
 *
 * @文件名称： FirmQueryService.java
 * @包 路  径： com.trust.ywx.customer.service.query
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/14 19:34
 * @Modify：
 */
public interface FirmQueryService {

    //-------------------------可信客户--------------------
    /**
     * 获取可信客户列表 (fixme 量大的话，不应该提供一次返回全量数据的接口)
     * @param param
     * @return
     */
    List<TrustFirmDto> getTrustFirmList(SearchTrustFirmParam param);

    /**
     * 获取可信客户列表 （分页）
     * @param param
     * @return
     */
    PageList<List<TrustFirmDto>> getTrustFirmListWithPage(SearchTrustFirmParam param);

    /**
     * 获取可信客户详情 （不包括证书和厂商图标信息）
     * @param clientId
     * @return
     */
    TrustFirmDto getTrustFirm(String clientId);
    TrustFirmDto getTrustFirmWithBLOBs(String clientId);

    /**
     * 获取客户配置属性集合
     * 主要给customer-client内部使用！
     */
    Map<String,String> getAllProp(String clientId);

    /**
     * 根据属性值获取客户列表
     * fixme 要不要提供这个接口呢？
     * 例如：白名单 感觉最好是明确获取白名单的接口
     */
//    List<TrustFirmDto> getListByProp(String propName,String propValue);

    /**
     * 查询客户白名单
     * @param firmName
     * @return
     */
    List<TrustFirmDto> getFirmWhite(String firmName);

    //------------------------临时客户--------------------
    /**
     * 获取待审核客户列表
     * @param param
     */
    List<TempFirmDto> getTempFirmList(SearchFirmParam param);


    //-------------------------北京CA客户------------------------
    /**
     * 获取CRM<北京CA,...>客户列表
     * @param param
     */
    List<CrmFirmDto> getCrmFirmList(SearchCrmFirmParam param);




}
