package com.trust.ywx.customer;

import com.trust.ywx.customer.common.enu.CaChannelEnum;
import com.trust.ywx.customer.common.enu.CommonStatusEnum;
import com.trust.ywx.customer.common.enu.ProjectStatusEnum;
import com.trust.ywx.customer.common.model.manager.request.TrustFirmParam;
import com.trust.ywx.customer.common.exception.BizException;
import com.trust.ywx.customer.service.manager.FirmManagerService;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;

/**
 * <pre></pre>
 *
 * @文件名称： FirmServiceTests.java
 * @包 路  径： com.trust.ywx.customer
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/20 17:19
 * @Modify：
 */

@Slf4j
@SpringBootTest(classes = Application.class)
public class FirmServiceTests {
    @Resource
    FirmManagerService firmManagerService;

    @Test
    public void addTest() throws BizException {
        TrustFirmParam param = new TrustFirmParam();
        param.setClientId("12345");
        param.setAppSecret("123456");
        param.setClientOrgCode("678910");
        param.setFirmName("莆田医院");
        param.setProjectStatus(ProjectStatusEnum.NORMAL.getCode());
        param.setCaChannel(CaChannelEnum.BJCA.getChannel());

        param.setTechSupport(CommonStatusEnum.NO.getCode());
        param.setSmsSend(CommonStatusEnum.YES.getCode());
        param.setSmsCustomize(CommonStatusEnum.YES.getCode());
        param.setSmsCustomizeContent("我的短信我做主");
        firmManagerService.add(param);
        System.out.println("success");
    }

    @Test
    public void delTest(){
        firmManagerService.delete("12345");
    }
}
